---
# - play.frontend.yml
- hosts: localhost
  tasks:
    - include_vars: vars/project.yml

    - name: building the frontend from source
      command: yarn build
      args:
        chdir: "{{ playbook_dir }}/frontend/"
      register: command_result

    - debug:
        var: command_result

    - name: archiving the build result
      archive:
        path: "{{ playbook_dir }}/frontend/build/"
        dest: "{{ playbook_dir }}/frontend.zip"
        format: zip
      register: archive_result

    - debug:
        var: archive_result

- hosts: [ web ]
  become: yes
  become_user: www-data
  tasks:
    - include_vars: vars/project.yml

    - name: checking if host is up
      ping:

    - name: purging old remote directory containing the application
      file:
        state: absent
        path: "/var/www/{{ project_name }}/frontend"

    - name: creating a remote directory for the application
      file:
        state: directory
        path: "/var/www/{{ project_name }}/frontend"
        mode: 0700
        owner: www-data
        group: www-data

    - name: extracting the frontend's archive to application directory
      unarchive:
        src: "{{ playbook_dir }}/frontend.zip"
        dest: /var/www/{{ project_name }}/frontend
        owner: www-data
        group: www-data
